package org.opencdmp.commonmodels.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpAccessType implements EnumValueProvider<Short> {

    Public((short) 0), Restricted((short) 1);

    private final Short value;

    DmpAccessType(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpAccessType> map = EnumUtils.getEnumValueMap(DmpAccessType.class);

    public static DmpAccessType of(Short i) {
        return map.get(i);
    }

}

