package org.opencdmp.commonmodels.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpBlueprintExtraFieldDataType implements EnumValueProvider<Short> {

    Text((short) 0),
    RichTex((short) 1),
    Date((short) 2),
    Number((short) 3),
    ;

    private final Short value;

    DmpBlueprintExtraFieldDataType(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpBlueprintExtraFieldDataType> map = EnumUtils.getEnumValueMap(DmpBlueprintExtraFieldDataType.class);

    public static DmpBlueprintExtraFieldDataType of(Short i) {
        return map.get(i);
    }

}
