package org.opencdmp.commonmodels.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpBlueprintStatus implements EnumValueProvider<Short> {

    Draft((short) 0),
    Finalized((short) 1);

    private final Short value;

    DmpBlueprintStatus(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpBlueprintStatus> map = EnumUtils.getEnumValueMap(DmpBlueprintStatus.class);

    public static DmpBlueprintStatus of(Short i) {
        return map.get(i);
    }

}
