package org.opencdmp.commonmodels.models.dmp;

import org.opencdmp.commonmodels.enums.DmpAccessType;
import org.opencdmp.commonmodels.enums.DmpStatus;
import org.opencdmp.commonmodels.models.DmpUserModel;
import org.opencdmp.commonmodels.models.EntityDoiModel;
import org.opencdmp.commonmodels.models.FileEnvelopeModel;
import org.opencdmp.commonmodels.models.UserModel;
import org.opencdmp.commonmodels.models.description.DescriptionModel;
import org.opencdmp.commonmodels.models.dmpblueprint.DmpBlueprintModel;
import org.opencdmp.commonmodels.models.dmpdescriptiontemplate.DmpDescriptionTemplateModel;
import org.opencdmp.commonmodels.models.dmpreference.DmpReferenceModel;

import java.time.Instant;
import java.util.UUID;
import java.util.List;

public class DmpModel {
    private UUID id;
    private short version;
    private String label;
    private String description;
    private DmpAccessType accessType;
    private DmpStatus status;
    private UserModel creator;
    private DmpBlueprintModel dmpBlueprint;
    private DmpPropertiesModel properties;
    private List<EntityDoiModel> entityDois;
    private List<DescriptionModel> descriptions;
    private List<DmpUserModel> users;
    private List<DmpReferenceModel> references;
    private List<DmpDescriptionTemplateModel> descriptionTemplates;
    private FileEnvelopeModel pdfFile;
    private FileEnvelopeModel rdaJsonFile;
    private FileEnvelopeModel supportingFilesZip;
    private String previousDOI;
    private Instant finalizedAt;
    private Instant publicAfter;
    private Instant updatedAt;
    private Instant createdAt;
    private String language;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public short getVersion() {
        return version;
    }

    public void setVersion(short version) {
        this.version = version;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public DmpAccessType getAccessType() {
        return accessType;
    }

    public void setAccessType(DmpAccessType accessType) {
        this.accessType = accessType;
    }

    public List<DmpUserModel> getUsers() {
        return users;
    }

    public void setUsers(List<DmpUserModel> users) {
        this.users = users;
    }

    public List<DmpReferenceModel> getReferences() {
        return references;
    }

    public void setReferences(List<DmpReferenceModel> references) {
        this.references = references;
    }

    public FileEnvelopeModel getPdfFile() {
        return pdfFile;
    }

    public void setPdfFile(FileEnvelopeModel pdfFile) {
        this.pdfFile = pdfFile;
    }

    public FileEnvelopeModel getRdaJsonFile() {
        return rdaJsonFile;
    }

    public void setRdaJsonFile(FileEnvelopeModel rdaJsonFile) {
        this.rdaJsonFile = rdaJsonFile;
    }

    public FileEnvelopeModel getSupportingFilesZip() {
        return supportingFilesZip;
    }

    public void setSupportingFilesZip(FileEnvelopeModel supportingFilesZip) {
        this.supportingFilesZip = supportingFilesZip;
    }

    public String getPreviousDOI() {
        return previousDOI;
    }

    public void setPreviousDOI(String previousDOI) {
        this.previousDOI = previousDOI;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }

    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public List<DescriptionModel> getDescriptions() {
        return descriptions;
    }

    public void setDescriptions(List<DescriptionModel> descriptions) {
        this.descriptions = descriptions;
    }

    public DmpStatus getStatus() {
        return status;
    }

    public void setStatus(DmpStatus status) {
        this.status = status;
    }

    public DmpBlueprintModel getDmpBlueprint() {
        return dmpBlueprint;
    }

    public void setDmpBlueprint(DmpBlueprintModel dmpBlueprint) {
        this.dmpBlueprint = dmpBlueprint;
    }

    public UserModel getCreator() {
        return creator;
    }

    public void setCreator(UserModel creator) {
        this.creator = creator;
    }

    public DmpPropertiesModel getProperties() {
        return properties;
    }

    public void setProperties(DmpPropertiesModel properties) {
        this.properties = properties;
    }

    public Instant getPublicAfter() {
        return publicAfter;
    }

    public void setPublicAfter(Instant publicAfter) {
        this.publicAfter = publicAfter;
    }

    public List<EntityDoiModel> getEntityDois() {
        return entityDois;
    }

    public void setEntityDois(List<EntityDoiModel> entityDois) {
        this.entityDois = entityDois;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public List<DmpDescriptionTemplateModel> getDescriptionTemplates() {
        return descriptionTemplates;
    }

    public void setDescriptionTemplates(List<DmpDescriptionTemplateModel> descriptionTemplates) {
        this.descriptionTemplates = descriptionTemplates;
    }
}
